///////////////////////////////////////////////////////////////////////////////////
///
///
///	\file	CMessageClient.cpp
///	\author	Rob Bateman
/// \brief	this file defines the class CMessageClient which is a simple example
///			of a possible use for the underlying templates. 
///	
///

///////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////
//
//	Includes
//
#define WIN32_LEAN_AND_MEAN
#include "CMessageClient.h"



///////////////////////////////////////////////////////////////////////////////////
//
//	TMessageCheck static functions

std::string TMessageCheck::GetClientName() {
	return CMessageClient::GetClientName();
}

	
///	\brief	the function operator to process the message
///
void TMessageCheck::operator()( std::istream &ifs )
{
	//	a buffer
	char buffer[ BUFFER_SIZE ];
	std::string msgIsFor, msgIsFrom, message;
		
		
	//	split the text apart
	//
	ifs >> msgIsFor;
		
	//	check for rubbish
	//
	if( msgIsFor == "" ) {return;}
			
	//	split the rest
	//
	ifs >> msgIsFrom;
	ifs.getline( buffer, BUFFER_SIZE, '\n' );
	message = buffer;

	//	if for all, or you, process message
	//
	if( (msgIsFor == "all" || 
		 msgIsFor == GetClientName()) && 
		 message != "" && message != " " )
	{
		//	print message
		//
		std::cout << "[" 
				  << msgIsFrom 
				  << "] " 
				  << message 
				  << std::endl<< "> ";
				  
		std::cout.flush();			
	}
}


///////////////////////////////////////////////////////////////////////////////////
//
//	CMessageClient static functions


///	\brief	this functions sends a text message to the server
///	\param	text	-	the message to send
///	\param	user	-	the user name to whom to send the message (or "all")
///	\return	true if OK
///
bool CMessageClient::SendText( std::string text, std::string user ) 
{
	BufferStream() << user 
				   << " " 
				   << GetClientName() 
				   << " " 
				   << text;
	return Send();
} 


